package info.bukova.isspst.data;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;

import org.hibernate.validator.constraints.NotBlank;

@Entity
@Table(name = "MUNIT")
public class MUnit extends BaseData implements DataModel {

	@Column(name = "CODE", unique = true)
	private String code;

	@Column(name = "NAME")
	private String name;

	@Column(name = "DESCRIPTION")
	private String description;

	/**
	 * @return the code
	 */
	@NotBlank(message = "{MUnitsFormCodeConstr}")
	public String getCode() {
		return code;
	}

	/**
	 * @param code
	 *            the code to set
	 */
	public void setCode(String code) {
		this.code = code;
	}

	/**
	 * @return the name
	 */
	public String getName() {
		return this.name;
	}

	/**
	 * @param name
	 *            the name to set
	 */
	public void setName(String name) {
		this.name = name;
	}
	
	public String getNameSpecial()
	{
		String special = this.getName();
		
		if (special != null)
		{
			special = special.replace("[up]2[/up]", "²");
		}
		
		return special;
	}
	
	public void setNameSpecial(String special)
	{
		if (special != null)
		{
			special = special.replace("²", "[up]2[/up]");
			
		}

		this.setName(special);
	}

	/**
	 * @return the description
	 */
	public String getDescription() {
		return description;
	}

	/**
	 * @param description
	 *            the description to set
	 */
	public void setDescription(String description) {
		this.description = description;
	}
}
