package info.bukova.isspst.data;

import java.util.Date;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Table;

@Entity
@Table(name = "REQUIREMENT")
public class Requirement extends BaseData implements DataModel
{
	@Column(name = "NUMSER", unique = true)
	private String numser;

	@Column(name = "REQDATE")
	private Date reqDate;

	@Column(name = "DELIVERYDATE")
	private Date deliveryDate;

	@ManyToOne(fetch = FetchType.EAGER)
	@JoinColumn(name = "WORKGROUP_ID")
	private Workgroup workgroup;

	@Column(name = "DESCRIPTION")
	private String description;

	@OneToMany(fetch = FetchType.EAGER, cascade=CascadeType.ALL)
	@JoinColumn(name = "REQUIREMENT_ID")
	private List<RequirementItem> items;
	
	public List<RequirementItem> getItems()
	{
		return items;
	}

	public void setItems(List<RequirementItem> items)
	{
		this.items = items;
	}

	public String getNumser()
	{
		return numser;
	}

	public void setNumser(String numser)
	{
		this.numser = numser;
	}

	public Date getReqDate()
	{
		return reqDate;
	}

	public void setReqDate(Date reqDate)
	{
		this.reqDate = reqDate;
	}

	public Date getDeliveryDate()
	{
		return deliveryDate;
	}

	public void setDeliveryDate(Date deliveryDate)
	{
		this.deliveryDate = deliveryDate;
	}

	public Workgroup getWorkgroup()
	{
		return workgroup;
	}

	public void setWorkgroup(Workgroup workgroup)
	{
		this.workgroup = workgroup;
	}

	public String getDescription()
	{
		return description;
	}

	public void setDescription(String description)
	{
		this.description = description;
	}
}
