package info.bukova.isspst.data;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.FetchType;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.MappedSuperclass;
import javax.persistence.OneToMany;

import org.hibernate.annotations.LazyCollection;
import org.hibernate.annotations.LazyCollectionOption;

@MappedSuperclass
public class RequirementBase extends BaseData {
	
	@ManyToOne(fetch = FetchType.EAGER)
	@JoinColumn(name = "TYPE_ID")
	private RequirementType type;
	@Column(name = "NUMSER", unique = true)
	private String numser;
	@Column(name = "REQ_DATE")
	private Date reqDate;
	@Column(name = "DESCRIPTION")
	private String description;
	@ManyToOne(fetch = FetchType.EAGER)
	@JoinColumn(name = "WORKGROUP_ID")
	private Workgroup workgroup;
	@OneToMany(cascade = CascadeType.ALL, orphanRemoval = true)
	@LazyCollection(LazyCollectionOption.FALSE)
	private List<AuthItem> authorization;
	@Column(name = "STATE")
	@Enumerated(EnumType.ORDINAL)
	private RequirementState state;
	
	public RequirementBase() {
		authorization = new ArrayList<AuthItem>();
	}

	public RequirementType getType() {
		return type;
	}

	public void setType(RequirementType type) {
		this.type = type;
	}

	public String getNumser() {
		return numser;
	}

	public void setNumser(String number) {
		this.numser = number;
	}

	public Date getReqDate() {
		return reqDate;
	}

	public void setReqDate(Date reqDate) {
		this.reqDate = reqDate;
	}

	public Workgroup getWorkgroup() {
		return workgroup;
	}

	public void setWorkgroup(Workgroup workgroup) {
		this.workgroup = workgroup;
	}

	public List<AuthItem> getAuthorization() {
		return authorization;
	}

	public void setAuthorization(List<AuthItem> authorization) {
		this.authorization = authorization;
	}

	public RequirementState getState() {
		return state;
	}

	public void setState(RequirementState state) {
		this.state = state;
	}

}
