package info.bukova.isspst.ui.requirement;

import info.bukova.isspst.data.Requirement;
import info.bukova.isspst.data.RequirementItem;
import info.bukova.isspst.data.Workgroup;
import info.bukova.isspst.services.requirement.RequirementService;
import info.bukova.isspst.services.users.UserService;
import info.bukova.isspst.services.workgroups.WorkgroupService;
import info.bukova.isspst.ui.FormViewModel;

import java.util.List;

import org.zkoss.bind.annotation.BindingParam;
import org.zkoss.bind.annotation.Command;
import org.zkoss.bind.annotation.Init;
import org.zkoss.bind.annotation.NotifyChange;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.select.annotation.WireVariable;
import org.zkoss.zul.Window;

public class RequirementForm extends FormViewModel<Requirement>
{
	@WireVariable
	private UserService userService;

	@WireVariable
	private WorkgroupService workgroupService;

	public List<Workgroup> getCentres()
	{
		return workgroupService.getUserCentres(userService.getCurrent());
	}

	@WireVariable
	private RequirementService requirementService;

	private RequirementItem item;

	private int selItemIndex;

	@Init(superclass = true)
	public void init()
	{
		this.setSelItemIndex(-1);
	}

	public RequirementItem getItem()
	{
		return item;
	}

	public void setItem(RequirementItem item)
	{
		this.item = item;
	}

	public int getSelItemIndex()
	{
		return selItemIndex;
	}

	public void setSelItemIndex(int selItemIndex)
	{
		this.selItemIndex = selItemIndex;
	}

	@Command
	@NotifyChange({ "dataBean", "selItemIndex" })
	public void addItem()
	{
		Window window = (Window) Executions.createComponents("/requirements/selectitems/selectItems.zul", null, null);
		window.doModal();
	}

	@Command
	@NotifyChange({ "dataBean", "selItemIndex" })
	public void removeItem(@BindingParam("item") RequirementItem item)
	{
//		requirementService.removeItem(getDataBean(), item);
		selItemIndex = -1;
	}

}
